//////////////////////////////////////////////////////////////////////////
//  This program is designed to read text from a file 
//  and to print the text to the screen, but
//  with upper-case text converted to lower-case text
//  and vice-versa.
//                     thomas l. gibson  November 13, 2002
//////////////////////////////////////////////////////////////////////////
#include <iostream>
#include <fstream>
#include <cstdlib>
using namespace std;

int main() 
{
  const int max = 75;
  int int_c;
  char c;
  char file_name[max + 1];               // Char array for file name
  const int offset = 32;                 // Ascii offset value
                                         // for upper/lower conversion
  const int upper_min = 65;              // Min decimal ascii for upper
  const int upper_max = 90;              // Max decimal ascii for upper
  const int lower_min = 97;              // Min decimal ascii for lower
  const int lower_max = 122;             // Max decimal ascii for upper
  system("clear");
  cout << "Please input the file name to be opened: ";
  cin.get(file_name,max + 1);            // Hey look, a c-string
  cout << "\n\n";
  ifstream rd_1;
  rd_1.open(file_name, ios::in);         // No need for .c_str()
  if( rd_1.fail() )
  {
    cout << "Could not open file " << file_name << endl;
    return EXIT_FAILURE;
  }
  else
  {
    cout << "File " << file_name << " opened successfully\n\n";
  }
  cout << "We will convert upper-case to lower-case and" << endl;
  cout << "lower-case to upper-case for the file "
       << file_name << "\n\n" << endl;
  while ( rd_1.get(c) )                  // Read 1 char at a time
  {
    int_c = (int) c;                     // Cast char to int
    if ((int_c >= upper_min) && (int_c <= upper_max))
    {
      int_c += offset;
      cout.put((char) int_c);            // Cast int to char
    }                                    // and write to screen
    else if ((int_c >= lower_min) && (int_c <= lower_max))
    {
      int_c -= offset;
      cout.put((char) int_c);            // Cast int to char
    }                                    // and write to screen
    else
    {
      cout.put(c);
    }
  }
  rd_1.close();
  return EXIT_SUCCESS;
}
