//////////////////////////////////////////////////////////////////////////
//  This program is designed to read text from a file 
//  and to print the text to the screen, but
//  with upper-case text converted to lower-case text
//  or lower-case converted to upper-case or both.  The
//  converted text is also written to file case_invert.out.
//
//                     thomas l. gibson  November 13, 2002
//////////////////////////////////////////////////////////////////////////
#include <iostream>
#include <fstream>
#include <cstdlib>
using namespace std;

int main() 
{
  const int max = 75;
  int int_c;
  char c;
  char file_name[max + 1];               // Char array for file name
  const int offset = 32;                 // Ascii offset value
                                         // for upper/lower conversion
  int option = 0;
  int up_shift = 0;
  int down_shift = 0;             
  const int upper_min = 65;              // Min decimal ascii for upper
  const int upper_max = 90;              // Max decimal ascii for upper
  const int lower_min = 97;              // Min decimal ascii for lower
  const int lower_max = 122;             // Max decimal ascii for upper
  system("clear");
  cout << "Please input the file name to be opened: ";
  cin.get(file_name,max + 1);            // Hey look, a c-string
  cout << "\n\n";
  ifstream rd_1;
  rd_1.open(file_name, ios::in);         // No need for .c_str()
  if( rd_1.fail() )
  {
    cout << "Could not open file " << file_name << endl;
    return EXIT_FAILURE;
  }
  else
  {
    cout << "File " << file_name << " opened successfully\n\n";
  }

  start:
  cout << "Options:\n";
  cout << "\t(1) Flip upper-case to lower-case\n";
  cout << "\t(2) Flip lower-case to upper-case\n";
  cout << "\t(3) Do both options (1) and (2)\n";
  cout << "\t\tInput option: ";
  cin >> option;
  cout << "\n";

  switch (option)
  {
    case 1:
      up_shift = offset;
      break;
    case 2:
      down_shift = offset;
      break;
    case 3:
      up_shift = offset;
      down_shift = offset;
      break;
    default:
      goto start;
  }    
  ofstream prt_1;
  prt_1.open("case_invert.out", ios::out);
  while ( rd_1.get(c) )                  // Read 1 char at a time
  {
    int_c = (int) c;                     // Cast char to int
    if ((int_c >= upper_min) && (int_c <= upper_max))
    {
      int_c += up_shift;
      cout.put((char) int_c);
      prt_1.put((char) int_c);
    }
    else if ((int_c >= lower_min) && (int_c <= lower_max))
    {
      int_c -= down_shift;
      cout.put((char) int_c);
      prt_1.put((char) int_c);
    }
    else
    {
      cout.put(c);
      prt_1.put(c);
    }
  }
  rd_1.close();
  prt_1.close();
  cout << "\n\n\n\t**** Output file --> case_invert.out ****\n";
  return EXIT_SUCCESS;
}
